function abort(str1, str2, str3, str4)
% abort: Replaces error()
% ---------------------------------------
% TASK:
%   The function is identical to error(), except that it works.
% IN:
%   strings to be displayed. Omitted arguments are not displayed.
%   If the first argument is []: Display 'aborted' and issue KEYBOARD so that
%   user can inspect the problem.

% AUTHOR: Lutz Hendricks, 1993-97
% ---------------------------------------


disp(' ')
disp('--- ABORT ---------------------------------------')
if nargin > 0
    if ~isempty(str1)
        disp(str1)
        keyboardOn = 0;
    else
        keyboardOn = 1;
    end
end

if nargin > 1
    disp(str2)
end
if nargin > 2
    disp(str3)
end
if nargin > 3
    disp(str4)
end

disp('-------------------------------------------------')

if keyboardOn == 1
    disp('---Keyboard activated---')
    keyboard
end
diary off


% *** The following syntax error crashed Matlab. This is the only reliable
%   way to stop a running program. error() does not always work.

% Do not use error() here!
ABBRUCH


% *** end function ***

